org.apache.poi.xwpf.usermodel

## Class XWPFNumbering

- java.lang.Object
- - org.apache.poi.ooxml.POIXMLDocumentPart
  - - org.apache.poi.xwpf.usermodel.XWPFNumbering

-     public class XWPFNumbering
      extends POIXMLDocumentPart

  Author:
    Philipp Epp

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.poi.ooxml.POIXMLDocumentPart

      `POIXMLDocumentPart.RelationPart`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.List<XWPFAbstractNum>` | `abstractNums`
    `protected java.util.List<XWPFNum>` | `nums`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XWPFNumbering()` create a new XWPFNumbering object for use in a new document
    `XWPFNumbering(PackagePart part)` create a new styles object with an existing document

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.math.BigInteger` | `addAbstractNum(XWPFAbstractNum abstractNum)` add a new AbstractNum and return its AbstractNumID
    `java.math.BigInteger` | `addNum(java.math.BigInteger abstractNumID)` Add a new num with an abstractNumID
    `void` | `addNum(java.math.BigInteger abstractNumID, java.math.BigInteger numID)` Add a new num with an abstractNumID and a numID
    `java.math.BigInteger` | `addNum(XWPFNum num)` add a new number to the numbering document
    `protected void` | `commit()` save and commit numbering
    `XWPFAbstractNum` | `getAbstractNum(java.math.BigInteger abstractNumID)` get AbstractNum by abstractNumID
    `java.math.BigInteger` | `getAbstractNumID(java.math.BigInteger numID)` return the abstractNumID If the AbstractNumID not exists return null
    `java.math.BigInteger` | `getIdOfAbstractNum(XWPFAbstractNum abstractNum)` Compare AbstractNum with abstractNums of this numbering document.
    `XWPFNum` | `getNum(java.math.BigInteger numID)` get Num by NumID
    `boolean` | `numExist(java.math.BigInteger numID)` Checks whether number with numID exists
    `protected void` | `onDocumentRead()` read numbering form an existing package
    `boolean` | `removeAbstractNum(java.math.BigInteger abstractNumID)` remove an existing abstractNum
    `void` | `setNumbering(org.openxmlformats.schemas.wordprocessingml.x2006.main.CTNumbering numbering)` Sets the ctNumbering

    - ### Methods inherited from class org.apache.poi.ooxml.POIXMLDocumentPart

      `_invokeOnDocumentRead, addRelation, createRelationship, createRelationship, createRelationship, getNextPartNumber, getPackagePart, getParent, getRelationById, getRelationId, getRelationPartById, getRelationParts, getRelations, getTargetPart, isCommited, isCommitted, onDocumentCreate, onDocumentRemove, onSave, prepareForCommit, read, rebase, removeRelation, removeRelation, removeRelation, setCommited, setCommitted, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### abstractNums

          protected java.util.List<XWPFAbstractNum> abstractNums

    - #### nums

          protected java.util.List<XWPFNum> nums

  - ### Constructor Detail

    - #### XWPFNumbering

          public XWPFNumbering(PackagePart part)

      create a new styles object with an existing document
      Since:
        POI 3.14-Beta1

    - #### XWPFNumbering

          public XWPFNumbering()

      create a new XWPFNumbering object for use in a new document

  - ### Method Detail

    - #### onDocumentRead

          protected void onDocumentRead()
                                 throws java.io.IOException

      read numbering form an existing package
      Overrides:
        `onDocumentRead` in class `POIXMLDocumentPart`
      Throws:
        `java.io.IOException` - a subclass may throw an IOException when a document is read

    - #### commit

          protected void commit()
                         throws java.io.IOException

      save and commit numbering
      Overrides:
        `commit` in class `POIXMLDocumentPart`
      Throws:
        `java.io.IOException` - a subclass may throw an IOException if the changes can't be committed

    - #### setNumbering

          public void setNumbering(org.openxmlformats.schemas.wordprocessingml.x2006.main.CTNumbering numbering)

      Sets the ctNumbering
      Parameters:
        `numbering` -

    - #### numExist

          public boolean numExist(java.math.BigInteger numID)

      Checks whether number with numID exists
      Parameters:
        `numID` -
      Returns:
        boolean true if num exist, false if num not exist

    - #### addNum

          public java.math.BigInteger addNum(XWPFNum num)

      add a new number to the numbering document
      Parameters:
        `num` -

    - #### addNum

          public java.math.BigInteger addNum(java.math.BigInteger abstractNumID)

      Add a new num with an abstractNumID
      Returns:
        return NumId of the added num

    - #### addNum

          public void addNum(java.math.BigInteger abstractNumID,
                             java.math.BigInteger numID)

      Add a new num with an abstractNumID and a numID
      Parameters:
        `abstractNumID` -
        `numID` -

    - #### getNum

          public XWPFNum getNum(java.math.BigInteger numID)

      get Num by NumID
      Parameters:
        `numID` -
      Returns:
        abstractNum with NumId if no Num exists with that NumID null will be returned

    - #### getAbstractNum

          public XWPFAbstractNum getAbstractNum(java.math.BigInteger abstractNumID)

      get AbstractNum by abstractNumID
      Parameters:
        `abstractNumID` -
      Returns:
        abstractNum with abstractNumId if no abstractNum exists with that abstractNumID null will be returned

    - #### getIdOfAbstractNum

          public java.math.BigInteger getIdOfAbstractNum(XWPFAbstractNum abstractNum)

      Compare AbstractNum with abstractNums of this numbering document. If the content of abstractNum equals with an abstractNum of the List in numbering the BigInteger Value of it will be returned. If no equal abstractNum is existing null will be returned
      Parameters:
        `abstractNum` -
      Returns:
        BigInteger

    - #### addAbstractNum

          public java.math.BigInteger addAbstractNum(XWPFAbstractNum abstractNum)

      add a new AbstractNum and return its AbstractNumID
      Parameters:
        `abstractNum` -

    - #### removeAbstractNum

          public boolean removeAbstractNum(java.math.BigInteger abstractNumID)

      remove an existing abstractNum
      Parameters:
        `abstractNumID` -
      Returns:
        true if abstractNum with abstractNumID exists in NumberingArray, false if abstractNum with abstractNumID not exists

    - #### getAbstractNumID

          public java.math.BigInteger getAbstractNumID(java.math.BigInteger numID)

      return the abstractNumID If the AbstractNumID not exists return null
      Parameters:
        `numID` -
      Returns:
        abstractNumID

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.